# Copyright (c) 2005 Universit de Lige, Nicolas Mazziotta
# $Id: Analysis.pm 189 2006-02-27 15:20:18Z mzi $
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.

require XML::Khartes;

use Carp;

use strict;

#######################################################
package XML::Khartes::Analysis;
#######################################################

sub new {
	my $proto = shift;
        my $class = ref($proto) || $proto;
	my $o = {
		khartes => undef,
		xml => undef,
		@_
	};
	bless($o, $class);
	return $o;
}

sub XML::Khartes::Analysis {
	my ($o) = @_;
	my ($analysisnode);
	foreach ( $o->{xml}->findnodes("/charte/analyse[1]") ) { $analysisnode = $_; last}
	return $o->{analysis} if $o->{analysis};
	my $analysis = XML::Khartes::Analysis->new(
			khartes => $o,
			xml => $analysisnode
	) unless !$analysisnode ;	
	$o->{analysis} = $analysis;
	return $analysis;
	return 0;
}

sub _people {
	# manipule les listes d'auteurs et de scelleurs
	my ($o, $type, %options) = @_;
	return 0 unless $o->{xml};
	# options:
	# add|remove => (list)
	$options{add} = [] unless $options{add};
	$options{remove} = [] unless $options{remove};

	my %people;
	
	my $peopleNode = "";
	map {$peopleNode = $_} $o->{xml}->findnodes("./$type"."s");
	unless ($peopleNode) {
		$peopleNode = $o->{xml}->appendChild($o->{xml}->ownerDocument->createElement($type."s"));
	}
	foreach ($peopleNode->findnodes("$type/nom")) {
		$people{$_->att("lemme")} = $_;
	}
	foreach my $lemma (@{$options{add}}) {
		unless (exists $people{$lemma}) {
			$lemma = "" if $lemma =~ /^[\d\W]/;
			my $new = $o->{xml}->ownerDocument->createElement($type);
			$new
			->appendChild($o->{xml}->ownerDocument->createElement("nom"))
			->att("lemme", $lemma);
			$peopleNode->appendChild($new);
			$people{$lemma} = $peopleNode;
		}	
	}
	foreach (@{$options{remove}}) {
		if (my $node = $people{$_}) {
			$o->{khartes}->delete($node->parentNode);
			delete $people{$_};
		}	
	}
	return %people;
}
sub authors {
	# manipule la liste des auteurs
	my ($o, %options) = @_;
	return $o->_people("auteur", %options);
}

sub sigillants {
	# manipule la liste des scelleurs
	my ($o, %options) = @_;
	return $o->_people("scelleur", %options);
}

sub actions {
	# TODO faire une fonction  part (ce n'est pas une personne)
	# manipule la liste des actions
	my ($o, %options) = @_;
	return $o->_people("action", %options);
}


1;

#######################################################
package XML::Khartes::Analysis::People;
#######################################################

sub new {
	my $proto = shift;
        my $class = ref($proto) || $proto;
	my $o = {
		type => undef,
		xml => undef,
		lemme => undef,
	};
	bless($o, $class);
	return $o;
}

1;
