# Copyright (c) 2006 Universit de Lige, Nicolas Mazziotta 
# $Id$
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
#######################################################
package  XML::Khartes::Server::DOM::Method;
# XXX Version DOM de XML::Khartes::Server::Method
# Beaucoup plus propre, mais ne peut grer les fichiers 
# trop gros (avec 1Go de RAM et 1Go de SWAP, provoque 
# 
# une erreur fatale sur un stream de 40Mo).
# Une classe abstraite qui permet de convertir des 
# appels de mthodes en xml et vice-versa.
#######################################################

use strict;

#=====================================================#
sub  new
#=====================================================#
{
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $object = {
		@_
	};
	bless($object, $class);
	return $object;
}

#=====================================================#
sub  object_method_args_to_xml
# transforme un tableau de scalaires en une chane xml
# Retourne: chane (XML srialis)
#=====================================================#
{
	my ($o, $object, $method, @args) = @_;
	my $xmldoc = XML::LibXML::Document->new();
	my $root = XML::LibXML::Element->new("query");
	$xmldoc->setDocumentElement($root);
	# si un seul argument est pass, ce n'est qu'une mthode applique
	#  l'objet "server" en remote.
	my $name = "object";
	$name = "method" unless $method;
	my $object_node = XML::LibXML::Element->new($name);
	$object_node->appendText($object);
	$root->appendChild($object_node);
	
	if ($method) {
		my $method_node = XML::LibXML::Element->new("method");
		$method_node->appendText($method);
		$root->appendChild($method_node);
		my $args_node = XML::LibXML::Element->new("arguments");

		if (@args) {
			foreach (@args) {
				my $arg_node = XML::LibXML::Element->new("argument");
				if (ref $_) {
					my $transport = XML::Khartes::Server::DOM::DataStruct->new();
					$transport->load_data_in_xmlnode($_)
				} else {
					$arg_node->appendText($_);
				}
				$args_node->appendChild($arg_node);
			}
			$root->appendChild($args_node);
		}
	} 
	
	my $xmlstring = $xmldoc->toString;
	return $xmlstring;
}

#=====================================================#
sub  object_method_args_from_xml
#=====================================================#
{
	my ($o, $xmlstring, $server) = @_;
	my ($object, $method, @args) = ();
	my $xmlparser = XML::LibXML->new; 
 	my $xmldoc = "";
	eval { $xmldoc = $xmlparser->parse_string($xmlstring) } or &msg($@) && return ();
	$object = $o->_get_object_fromxml($xmldoc);
	$method = $o->_get_method_fromxml($xmldoc);
	@args = $o->_get_args_fromxml($xmldoc, $server);
	return ($object, $method, @args);
}

#=====================================================#
sub  _get_object_fromxml
#=====================================================#
{
	my ($o, $xmldoc) = @_;
	foreach ($xmldoc->root->findnodes('/query/object/text()')) {
		return $_->toString;
	}
	return undef
}

#=====================================================#
sub  _get_method_fromxml
#=====================================================#
{
	my ($o, $xmldoc) = @_;
	foreach ($xmldoc->root->findnodes('/query/method/text()')) {
		return $_->toString;
	}
	return undef
}

#=====================================================#
sub  _get_args_fromxml
#=====================================================#
{
	my ($o, $xmldoc, $server) = @_;
	my @args = ();
	foreach ($xmldoc->root->findnodes('/query/arguments/argument')) {
		my $transport = XML::Khartes::Server::DOM::DataStruct->new();
		my $arg = $transport->read_data_from_xmlnode($_, $server);
		push @args, $arg;
	}
	return @args;
}


1;

# vim:ts=2 sw=2

