# Copyright (c) 2006 Universit de Lige, Nicolas Mazziotta 
# $Id$
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
#######################################################
package  XML::Khartes::Server::Method;
# Une classe abstraite qui permet de convertir des 
# appels de mthodes en xml et vice-versa.
#######################################################

use strict;
use Data::Dumper;

#=====================================================#
sub  new
#=====================================================#
{
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $object = {
		@_
	};
	bless($object, $class);
	return $object;
}

#=====================================================#
sub  object_method_args_to_xml
# transforme un tableau de scalaires en une chane xml
# Retourne: chane XML
# Je suis oblig de faire le XML " la main", parce que
# les documents sont trop gros pour le faire via 
# des objets DOM.
#=====================================================#
{
	my ($o, $object, $method, @args) = @_;
	my $string = "<?xml version='1.0' encoding='ISO-8859-1'?><query>";
	# si un seul argument est pass, ce n'est qu'une mthode applique
	#  l'objet "server" en remote.
	my $name = "object";
	$name = "method" unless $method;
	
	$string .= "<$name>".$object."</$name>";
	
	if ($method) {
		$string .= "<method>$method</method>";
		$string .= "<arguments>";
		if (@args) {
			foreach (@args) {
				$string .= "<argument>";
				if (ref $_) {
					my $transport = XML::Khartes::Server::DataStruct->new();
					$string .= $transport->load_data_in_xmlnode($_);
				} else {
					$string .= $_;
				}
				$string .= "</argument>";
			}
		}
		$string .= "</arguments>";
	} 
	$string .= "</query>";
	return $string;
}

#=====================================================#
sub  object_method_args_from_xml
#=====================================================#
{
	my ($o, $xmlstring, $server) = @_;
	my ($object, $method, @args) = ();
	my $xmlparser = XML::LibXML->new; 
 	my $xmldoc = "";
	eval { $xmldoc = $xmlparser->parse_string($xmlstring) } or &msg($@) && return ();
	$object = $o->_get_object_fromxml($xmldoc);
	$method = $o->_get_method_fromxml($xmldoc);
	@args = $o->_get_args_fromxml($xmldoc, $server);
	return ($object, $method, @args);
}

#=====================================================#
sub  _get_object_fromxml
#=====================================================#
{
	my ($o, $xmldoc) = @_;
	foreach ($xmldoc->root->findnodes('/query/object/text()')) {
		return $_->toString;
	}
	return undef
}

#=====================================================#
sub  _get_method_fromxml
#=====================================================#
{
	my ($o, $xmldoc) = @_;
	foreach ($xmldoc->root->findnodes('/query/method/text()')) {
		return $_->toString;
	}
	return undef
}

#=====================================================#
sub  _get_args_fromxml
#=====================================================#
{
	my ($o, $xmldoc, $server) = @_;
	my @args = ();
	foreach ($xmldoc->root->findnodes('/query/arguments/argument')) {
		my $xmlstring = $_->toString;
		my $transport = XML::Khartes::Server::DataStruct->new();
		my $xmlparser = XML::LibXML::SAX->new(Handler => SAXHandlers->new(server => $server)); 
		$xmlstring =~ s/(<\?xml version=['"]1.0['"])(\?>)/$1 encoding='ISO-8859-1' $2/;
		eval { $xmlparser->parse_string($xmlstring); } or print STDERR $@ && return ();
		push @args, @{$xmlparser->{Handler}{members}};
	}
	return @args;
}


1;

# vim:ts=2 sw=2

