# Copyright (c) 2005 Universit de Lige, Nicolas Mazziotta
# $Id: HidePane.pm 38 2005-11-01 09:18:13Z mzi $
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.


#######################################################
package Tk::HidePane;
#######################################################
# A widget that contains the text and ways to alter it

use strict;		
use lib "$ENV{HOME}/lib/perl";
use base qw/Tk::Frame/;
use Tk::TextUndo;

Construct Tk::Widget "HidePane";

# TODO: directions

sub ClassInit{
	my ($class,$mw) = @_;
	$class->SUPER::ClassInit($mw);
}

sub Populate {
	my ($w, $args) = @_;
	
	$w->{_invisible} = 0;
	
	$w->{arrow_up} = $w->Pixmap("arrow",
		-data => '/* XPM */
	static char * arrow_xpm[] = {
	"5 3 2 1",
	" 	c None",
	".	c #000000",
	"  .  "
	" ... "
	"....."};'
	);
	$w->{arrow_down} = $w->Pixmap("arrow_2",
		-data => '/* XPM */
	static char * arrow_xpm[] = {
	"5 3 2 1",
	" 	c None",
	".	c #000000",
	"....."
	" ... "
	"  .  "};'
	);

	
	my $buttonframe = $w->Frame->pack(-fill => "x", -anchor => "e");
	my $button = $buttonframe->Button(
		-command => sub  {
			$w->toggle;
		},
		-relief => "flat",
		-text => "hide", 
		-image=> $w->{arrow_up},
	)->pack(-side => "right");

	my $frame = $buttonframe->Frame->pack(-fill => "x");

	$w->Advertise("button" => $button);
	$w->Advertise("frame" => $frame);

	$w->Delegates(
		"DEFAULT" => $frame,
		"empty" => $w,
		"toggle" => $w,
	);

	$w->SUPER::Populate($args);
}

sub empty {
	my ($w) = @_;
	map {$_->destroy} $w->Subwidget("frame")->children
}

sub toggle {
	my ($w) = @_;
	my $f = $w->Subwidget("frame");
	my $b = $w->Subwidget("button");
	unless ($w->{_invisible}) {
		$w->{_invisible} = $f->packInfo;
		$b->configure(-image => $w->{arrow_down});
		$f->packForget;
	} else {
		$f->pack(@{$w->{_invisible}});
		$b->configure(-image => $w->{arrow_up});
		$w->{_invisible} = 0;
	}
}
1;

