# Copyright (c) 2005 Universit de Lige, Nicolas Mazziotta
# $Id: KhInfo.pm 33 2005-10-31 05:54:25Z mzi $
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.

use strict;		
use Tk::LabEntry;

use lib "$ENV{HOME}/lib/perl";

#######################################################
package Tk::KhInfo;
#######################################################

use base qw/Tk::Frame/;

Construct Tk::Widget "KhInfo";

sub ClassInit{
	my ($class,$mw) = @_;
	$class->SUPER::ClassInit($mw);
}

sub Populate {
	my ($w, $args) = @_;
	$w->SUPER::Populate($args);
	# Infos:
	$w->ConfigSpecs(-boxes => ["METHOD", "boxes", "Boxes", {}]);    # define cget() / configure() options
}

sub boxes {
	my ($w, $boxes) = @_;
	foreach my $key (sort keys %$boxes) {
		my $textvariable = "";
		my $e = $w->Component(
			"LabEntry", 
			"$key",
			-textvariable => \$textvariable,
			-labelPack => [-side => "left"], 
			-label => $key,
			-width => $boxes->{$key},
		)->pack(-side => "left");
		$e->bind("<KeyPress>" => sub {$e->configure(-foreground => "red")});
		$e->bind("<KeyRelease-Return>" => sub { 
			print STDERR "Don't worry about the error message\n";
			$w->toplevel->{_xml}->xml->root->setAttribute($key, $textvariable);
			$e->configure(-foreground => "black");
		}
		);
	}
	return $w;
}


sub loadInfo {
	my ($w, %infos) = @_;
	foreach my $name (keys %infos) {
		my $value = $infos{$name};
		my $box = "";
		eval {$box = $w->Subwidget($name)};	
		if ($box) {
			${$box->cget("-textvariable")} = $value;
		}
	}
	return $w;
}

1;


