# Copyright (c) 2005 Universit de Lige, Nicolas Mazziotta
# $Id: KhNoteBook.pm 154 2006-01-25 08:23:28Z mzi $
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.



#######################################################
package Tk::KhNoteBook;
#######################################################

use strict;		
use lib "$ENV{HOME}/lib/perl";

use base qw/Tk::NoteBook/;

Construct Tk::Widget "KhNoteBook";

sub ClassInit{
	my ($class,$mw) = @_;
	$class->SUPER::ClassInit($mw);
}

sub Populate {
	my ($w, $args) = @_;

	$args->{-tabpadx} = 2 unless $args->{-tabpadx} ; 
	$args->{-tabpady} = 2 unless $args->{-tabpady} ;
	$args->{-font} = "normal" unless $args->{-font};
        # FIXME
        #$args->{-backpagecolor} = $w->optionGet("background" => ref $w) unless $args->{-backpagecolor};
	
	$w->SUPER::Populate($args);
	
	# Affichage
	my %defaultPack = qw(
		-expand 1
		-fill both
		-side left
	);
	my %defaultBorder = qw(
		-relief groove
		-borderwidth 2
	);
	my %onglet;
}

sub delete {
	my ($w, $page) = @_;
	my %pages = ();
	map { $pages{$_} = 1 } $w->pages;
	$w->SUPER::delete($page) if $pages{$page};
	return $w;
}

sub clear {
	my $w = shift;
	map {$w->SUPER::delete($_)} $w->pages;
	return $w;
}

sub page {
	my ($w, $name) = @_;
	return $w->Subwidget($name);
}

sub goto_id {
  my ($w, $id) = @_;

  foreach ( keys %{ $w->{SubWidget} } ) {
    $w->raise($_);
    my $focused = $w->Subwidget("$_")->goto_id($id);
    if ($focused) { 
      return $focused;
    }
  }

  return 0;
}

sub tabAdd {
	my ($w, %options) = @_;
	my $tab = $w->add(
		$options{-name}, 
		-label => $options{-label},
	);
	my $sub = $options{"-widget"};
	
	my $new = $tab->Scrolled(
		$sub, 
		-scrollbars => "ose",
		%{$options{-options}}
	)
	->pack( @{ $options{'-pack'} } );

	unless (exists $options{-advertised} and ! $options{-advertised}){
		$w->Advertise(
			$options{-name} => $new
		);
	}

	return $new;
}

1;

