# Copyright (c) 2005 Universit de Lige, Nicolas Mazziotta
# $Id: KhTreeSearch.pm 154 2006-01-25 08:23:28Z mzi $
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.

use strict;		


#######################################################
package Tk::KhTreeSearch;
#######################################################

use base qw/Tk::Frame/;

Construct Tk::Widget "KhTreeSearch";

sub ClassInit{
  my ($class,$mw) = @_;
  $class->SUPER::ClassInit($mw);
}

sub Populate {
  my ($w, $args) = @_;

  $w->ConfigSpecs(
    -widget => ["METHOD", "widget", "Widget", undef],
  );
  $w->{-widget} = $args->{-widget};

  $w->SUPER::Populate($args);

  my $tree = $w->widget;
  my %headers = ();
  
  for (0 .. $tree->cget('-columns') - 2) {
    my $text = $tree->header('cget', $_, '-text');
    $headers{$text} = "" if $text;
  }

  my %replace = %headers;
  
  my $searchFrame = $w->Frame()->pack(-side => 'top');
  my $findFrame = $searchFrame->LabFrame(-label => "Rechercher (regexp)")->pack(-side => 'top');
  my $replFrame = $searchFrame->LabFrame(-label => "Remplacer par ('null' pour effacer)")->pack(-side => 'top');
  
  foreach (keys %headers) {
    $findFrame->LabEntry(-label => $_, -width=> 5, -textvariable => \$headers{$_}, -labelPack => [qw/-side left/])->pack(-side => "left");
  }

  foreach (keys %headers) {
    $replFrame->LabEntry(-label => $_, -width=> 5, -textvariable => \$replace{$_}, -labelPack => [qw/-side left/])->pack(-side => "left");
  }
  

  my $buttFrame = $w->Frame()->pack(-side => 'top');

  $w->Button(-text => ">", -command => sub { $w->widget->find('next',%headers) } )->pack(-side => 'left');
  $w->Button(-text => "<", -command => sub { $w->widget->find('prev',%headers) } )->pack(-side => 'left');
  $w->Button(-text => "Remplacer", -command => sub { $w->widget->find_replace('next', {%headers},{%replace}) } )->pack(-side => 'left');
  $w->Button(-text => "Remplacer tous", -command => sub { $w->widget->find_replace_all('next', {%headers},{%replace}) } )->pack(-side => 'left');
  $w->Button(-text => "Quitter", -command => sub { $w->toplevel->destroy } )->pack(-side => 'left');
  
}

sub widget {
  my ($w, $t) = @_;
  $w->{-widget} = $t if $t;
  return $w->{-widget}; 
}

sub search {
  my ($w, %params) = @_;
  
}

1;


