# Copyright (c) 2005 Universit de Lige, Nicolas Mazziotta
# $Id: KhWord.pm 38 2005-11-01 09:18:13Z mzi $
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.


#######################################################
package Tk::KhWord;
#######################################################
# A widget that contains the wordunit edition pane

use strict;		
use Tk::MatchEntry;
#use Tk::XMLText; # TODO= stg lighter

use base qw/Tk::LabFrame/;

Construct Tk::Widget "KhWord";

sub ClassInit{
	my ($class,$mw) = @_;
	$class->SUPER::ClassInit($mw);
}

sub Populate {
	my ($w, $args) = @_;
	$w->SUPER::Populate($args);
	my $addRemoveBox = $w->Frame()->pack(-side => "top");
		my $typeBox = $addRemoveBox->MatchEntry(-choices => [qw/w ponct mponct/], -width => 5)->pack(-side => "left");
		my $addBeforeButton = $addRemoveBox->Button(
			-image => "addleft",
			-text => "+a"
		)->pack(-side => "left");
		my $RemoveButton = $addRemoveBox->Button(
			-image => "delete",
			-text => "-"
		)->pack(-side => "left");
		my $addAfterButton = $addRemoveBox->Button(
			-image => "addright",
			-text => "a+"
		)->pack(-side => "left");
	my $xmlBox = $w->TextUndo(
		-wrap => "word",
		-width => 35,
		-height => 5,
	)->pack(-side => "top");
	my $splitJoinBox = $w->Frame()->pack(-side => "top");
		my $joinButton = $splitJoinBox->Button(-text => "-")->pack(-side => "left");
		my $splitButton = $splitJoinBox->Button(-text => "_")->pack(-side => "left");
		my $spaceButton = $splitJoinBox->Button(-text => " ")->pack(-side => "left");
		my $smallSpaceButton = $splitJoinBox->Button(-text => "|")->pack(-side => "left");
	my $validateBox = $w->Frame()->pack(-side => "top");
		my $applyButton = $validateBox->Button(
			#-image => "exec", # FIXME BADMATCH
			-text => "apply"
		)->pack(-side => "left");
		my $validateButton = $validateBox->Button(
			-image => "ok",
			-text => "validate",
			-command => [\&validate, $w]
		)->pack(-side => "left");
		my $resetButton = $validateBox->Button(
			-image => "no",
			-text => "reset",
			-command => [\&reset, $w]
		)->pack(-side => "left");
	$w->Delegates(
		"DEFAULT" => => $xmlBox
	);
}

sub validate {
	my ($w) = @_;
	my $text = $w->get("0.0", "e");
	my $parser = XML::LibXML->new();
	my $doc;
        eval { $doc = $parser->parse_string($text); };
	unless ($@) {
		my $encoding = $w->toplevel->{_xml}->xml->encoding;
		$doc->setEncoding($encoding);
		$doc->print;
	} else {
		my $reset = $w->toplevel->prompt(
			-text => "La chane que vous avez voulu vrifier n'est pas bien forme. Dsirez-vous rinitialiser le champ?"
		);
		$w->reset if $reset eq "oui";
	}
}

sub reset {
	my ($w) = @_;
	$w->update($w->{current_id});
	
}

sub update {
	my ($w, $id) = @_;
	my $xml = $w->toplevel->{_xml};
	return 0 unless $xml;
	my $string = $xml->elt_id($id)->toString(1);
	$string =~ s/\s+/ /gs;
	$w->{current_id} = $id;
	$w->delete("0.0","end");
	$w->insert("end", $string);
}



1;

